
/************************************************************************
 ** @author oflorian
 ** @since Mon Nov  3 12:13:19 2014
 ************************************************************************/

String.prototype.startsWith = function(str) {
	return this.substring(0, str.length) === str;
};

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:51:09 2014
 ************************************************************************/

String.prototype.endsWith = function(str) {
	return this.substring(this.length - str.length, this.length) === str;
};

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:51:05 2014
 ************************************************************************/

$(function() {
	$("img").on("click", function(evt) {
		var t = evt.target;
		ssbcallback("select_img", t.src);

		if (t.parentElement.classList.contains("selected")) {
			return false;
		}
		else {
			$(".ui-cropframe.selected").removeClass("selected");
			$(t).crop();
			t.parentElement.classList.add("selected");
			return false;
		}
	});
	$("body").on("click", function(evt) {
		var t = document.elementFromPoint(evt.clientX, evt.clientY);
		if (t.tagName == "A") {
			return true;
		}
		else if (t.classList.contains("ui-cropframe-handle") || t.classList.contains("ui-cropframe") || t.parentElement.classList.contains("ui-cropframe")) {
			return false;
		}
		else {
			$(".ui-cropframe.selected").removeClass("selected");
			mk_images();
			return false;
		}
	});

	$(document).on("copy", function(evt) {
		mk_images();
		get_profile();

		var selection = window.getSelection();
		if (selection.rangeCount > 0) {
			var range = selection.getRangeAt(0);
			var clonedSelection = best_selection(range);//range.cloneContents();

			var div = prepare_html(clonedSelection);

			var nrange = document.createRange();
			nrange.selectNode(div);
			selection.removeAllRanges();
			selection.addRange(nrange);

			var cleanup = true;
			if (cleanup) {
				setTimeout(function() {
					div.parentElement.removeChild(div);
					selection.removeAllRanges();
					selection.addRange(range);
				}, 300);
			}
		}
	});

	///----------------
	$("pre code").each(function(i, block) {
		hljs.highlightBlock(block);
	});

	///----------------
	$("img").each(function(i, img) {
		var src = img.getAttribute("src");
		var info = get_cookie("img_" + src);
		if (info) {
			$(img).crop();
			var p = img.parentElement;

			var a = info.split(":");

			var img_width = parseInt(a[1]);
			var crop_width = parseInt(a[3]);
			var crop_height = parseInt(a[4]);
			var crop_x = parseInt(a[5]);
			var crop_y = parseInt(a[6]);

			if (crop_width) p.style["width"] = crop_width + "px";
			if (crop_height) p.style["height"] = crop_height + "px";
			if (crop_x) img.style["margin-left"] = crop_x + "px";
			if (crop_y) img.style["margin-top"] = crop_y + "px";

			if (img_width != img.width) img.width = img_width;
		}
	});

	///---------------
	if (window.location.search == "?mode=present") {
		init_present();
	}

	document.PROCESSOR_READY = "yes";
});

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:58 2014
 ************************************************************************/

function post_process_html(html) {
	var div = document.createElement("div");
	div.innerHTML = html;
	$(div).find("img").each(function (n, it) {
		if (it.src.indexOf("file://") == 0) {
			var base = it.src.substr(it.src.lastIndexOf("/")+1);
			var imgsrc = prepare_image_path(base);

			if (imgsrc) {
				it.src = imgsrc;
			}
		}
	});

	return div.innerHTML;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:53 2014
 ************************************************************************/

function prepare_image_path(base) {
	var nfile = ssbcallback("prepare_image_path", base);
	return nfile;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:50 2014
 ************************************************************************/

function export_document(rtfmode) {
	mk_images();

	var div = prepare_html(document.body.cloneNode(true));
	var body = div.innerHTML;
	div.parentElement.removeChild(div);

	if (rtfmode) return div.innerHTML;
	else return window.EXPORTED_HTML;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:47 2014
 ************************************************************************/

function prepare_html(clonedSelection) {
	var div = document.createElement('div');
	div.style.position = "fixed";
	div.style.opacity = 0.0;
	div.style.top = 0;
	div.id = "dtmp";

	div.appendChild(clonedSelection);

	document.body.appendChild(div);

	cleanup_fragment(div);
	
	//inline css
	$(div).find(".hljs").each(function (n, it) {
		inline_css(it);
		it.removeAttribute("class");			
	});

	//cleanup center
	$(div).find("center").each(function(n, it) {
		var $cen = $(it);
		$cen.children().each(function(n, it) {
			if (it.tagName == "IMG") {
				var p = it.parentElement;
				if (p.tagName == "P") {
					p.style["text-align"] = "center";
				}
				else {
					var pp = document.createElement("P");
					pp.style["text-align"] = "center";
					$(it).replaceWith(pp);
					pp.appendChild(it);
				}
			}
			else {
				it.style["text-align"] = "center";
			}
		});

		$cen.replaceWith($cen.children());
	});

	//export html content
	window.EXPORTED_HTML = post_process_html(div.innerHTML);
	ssbcallback("set_html_content", window.EXPORTED_HTML);

	//add extra line for the RTF
	$(div).find("pre,ul,ol").each(function(n, it) {
		$(it).after("<br>");
	});

	return div;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:41 2014
 ************************************************************************/

function best_selection(range) {
	var p = range.commonAncestorContainer;
	if (p.tagName == "CODE") {
		if (p.parentElement.tagName == "PRE") return p.parentElement.cloneNode(true);
		else return p.cloneNode(true);
	}
	else {
		return range.cloneContents();
	}
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:38 2014
 ************************************************************************/

function inline_css(el) {
	var rules;
	for (var i = document.styleSheets.length - 1; i >= 0; i--) {
		if (document.styleSheets[i].cssRules) {
			rules = document.styleSheets[i].cssRules;
		}
		else if (document.styleSheets[i].rules) {
			rules = document.styleSheets[i].rules;
		}
		for (var idx = 0, len = rules.length; idx < len; idx++) {
			if (rules[idx].selectorText.indexOf("hover") == -1) {
				$(rules[idx].selectorText).each(function(i, elem) {
					if (isChildOf(elem, el)) {
						elem.style.cssText = rules[idx].style.cssText + elem.style.cssText;
						elem.removeAttribute("class");			
					}
				});
			}
		}
	}
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:33 2014
 ************************************************************************/

function isChildOf(el, par) {
	if (el == par) return true;
	var p = el.parentElement;
	while(p) {
		if (p == par) return true;
		p = p.parentElement;
	}
	return false;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:30 2014
 ************************************************************************/

function cleanup_fragment(el) {
	$(el).find(".ui-cropframe img").each(function(n, it) {
		var p = it.parentElement;
		p.parentElement.replaceChild(it, p);

		it.removeAttribute("width");
		it.style["margin-left"] = "";
		it.style["margin-top"] = "";
	});
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:27 2014
 ************************************************************************/

function mk_images() {
	var canvas = document.getElementById("ctmp");
	canvas = document.createElement("canvas");
	canvas.id = "ctmp";
	canvas.style.visibility = "hidden";
	canvas.style.display = "none";
	document.body.appendChild(canvas);

	$("img").each(function(n, it) {
		var info = get_img_info(it);
		var hash = ":" + info.w + ":" + info.h + ":" + info.cw + ":" + info.ch + ":" + info.cx + ":" + info.cy;

		if (info && info.cropped && hash != it.__last_hash) {
			canvas.width = info.cw;
			canvas.height = info.ch;
			var context = canvas.getContext("2d");
			context.drawImage(it, info.cx, info.cy, info.w, info.h);
			var data = canvas.toDataURL();
			var src = it.getAttribute("src");

			ssbcallback("save_image", src + "|" + data);
			it.__last_hash = hash;

			set_cookie("img_" + src, hash);
		}
	});

	canvas.parentElement.removeChild(canvas);
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:22 2014
 ************************************************************************/

function change_css(cssref) {
	var link = document.getElementById("doc_css_link");
	link.href = cssref;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:19 2014
 ************************************************************************/

function change_viewmode(type) {
	window.location = window.location.pathname + "?mode=" + type;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:16 2014
 ************************************************************************/

function init_present() {
	var divs = document.createElement("div");
	divs.classList.add("slides");

	var divr = document.createElement("div");
	divr.classList.add("reveal");
	divr.appendChild(divs);

	var sect = null;
	var ls = document.body.children;
	for (var i = 0; i < ls.length; i++) {
		var it = ls[i];
		if (it.tagName == "H1" || it.tagName == "H2" || it.tagName == "H3") {
			if (sect != null) divs.appendChild(sect);

			sect = document.createElement("section");
		}
		sect.appendChild(it);
	}

	if (sect != null) divs.appendChild(sect);

	document.body.innerHTML = "";
	document.body.appendChild(divr);

	//
	var css = document.getElementById("main_css_link");
	css.href = "ssb-include:///present.css";

	Reveal.initialize({
		// Display controls in the bottom right corner
		controls: true,
		// Display a presentation progress bar
		progress: true,
		// Display the page number of the current slide
		slideNumber: false,
		// Push each slide change to the browser history
		history: false,
		// Enable keyboard shortcuts for navigation
		keyboard: true,
		// Enable the slide overview mode
		overview: true,
		// Vertical centering of slides
		center: true,
		// Enables touch navigation on devices with touch input
		touch: true,
		// Loop the presentation
		loop: false,
		// Change the presentation direction to be RTL
		rtl: false,
		// Turns fragments on and off globally
		fragments: true,
		// Flags if the presentation is running in an embedded mode,
		// i.e. contained within a limited portion of the screen
		embedded: false,
		// Number of milliseconds between automatically proceeding to the
		// next slide, disabled when set to 0, this value can be overwritten
		// by using a data-autoslide attribute on your slides
		autoSlide: 0,
		// Stop auto-sliding after user input
		autoSlideStoppable: true,
		// Enable slide navigation via mouse wheel
		mouseWheel: false,
		// Hides the address bar on mobile devices
		hideAddressBar: true,
		// Opens links in an iframe preview overlay
		previewLinks: false,
		// Transition style
		transition: 'default',
		// default/cube/page/concave/zoom/linear/fade/none
		// Transition speed
		transitionSpeed: 'default',
		// default/fast/slow
		// Transition style for full page slide backgrounds
		backgroundTransition: 'default',
		// default/none/slide/concave/convex/zoom
		// Number of slides away from the current that are visible
		viewDistance: 3
	});
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:53:19 2014
 ************************************************************************/

function refresh_image(base) {
	$("img").each(function(i, img) {
		var src = img.getAttribute("src");
		if (src == base) {
			var p = img.parentElement;
			if (p.classList.contains("ui-cropframe")) {
				p.parentElement.replaceChild(img, p);

				img.removeAttribute("width");
				img.style["margin-left"] = "";
				img.style["margin-top"] = "";
			}
				
			img.src = img.src + "?" + (new Date()).getTime();

			setTimeout(function() {
				img.src = base;
			}, 1000);
		}
	});
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:10 2014
 ************************************************************************/

function get_img_info(img) {
	if (img) {
		var img_width = img.width;
		var img_height = img.height;
		var p = img.parentElement;
		if (p.classList.contains("ui-cropframe")) {
			var crop_width = p.style["width"].replace("px", "");
			var crop_height = p.style["height"].replace("px", "");
			var crop_x = img.style["margin-left"].replace("px", "");
			var crop_y = img.style["margin-top"].replace("px", "");

			if (crop_width != "") crop_width = parseInt(crop_width);
			else crop_width = 0;

			if (crop_height != "") crop_height = parseInt(crop_height);
			else crop_height = 0;

			if (crop_x != "") crop_x = parseInt(crop_x);
			else crop_x = 0;

			if (crop_y != "") crop_y = parseInt(crop_y);
			else crop_y = 0;

			return {
				"cropped": true,
				"w": img_width,
				"h": img_height,
				"cw": crop_width,
				"ch": crop_height,
				"cx": crop_x,
				"cy": crop_y
			};
		}
		else {
			return {
				"cropped": false,
				"w": img_width,
				"h": img_height
			};
		}
	}
	else return null;
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:49:59 2014
 ************************************************************************/

function get_profile() {
	var prof = ssbcallback("get_profile");

	if (prof) {
		var cfg = JSON.parse(prof);
		if (cfg) {
		}
	}
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:02 2014
 ************************************************************************/

function set_cookie(name, value, days) {
	ssbconfig_set(name, value);
}

/************************************************************************
 ** @author oflorian
 ** @since Thu Nov  6 20:50:05 2014
 ************************************************************************/

function get_cookie(name) {
	return ssbconfig_get(name);
}
